package com.takensoft.pohangTp.hwaSin.dao;

import org.apache.ibatis.annotations.Mapper;

import java.util.HashMap;
import java.util.List;

@Mapper
public interface HwaSinDAO {

    /**
     * 시간대별 평균 길이 Z축 마모
     *
     * @author 김성훈
     * @since 2024.01.18
     */
    public List<HashMap<String, Object>> timeZWear(String tl_no) throws Exception;

    /**
     * 월별 평균 길이 Z축 마모
     *
     * @author 김성훈
     * @since 2024.01.18
     */
    public List<HashMap<String, Object>> monthZWear(String tl_no) throws Exception;

    /**
     * 가동시간에 따른 각 툴별(도구) 길이 Z축 마모
     *
     * @author 김성훈
     * @since 2024.01.22
     */
    public List<HashMap<String, Object>> toolZWear();

    /**
     * 가동시간에 따른 각 툴별(도구) 길이 X축 마모
     *
     * @author 김성훈
     * @since 2024.01.22
     */
    public List<HashMap<String, Object>> toolXWear();
}
