package com.takensoft.pohangTp.meatKorea.dao;

import org.apache.ibatis.annotations.Mapper;

import java.util.HashMap;
import java.util.List;

@Mapper
public interface MeatKoreaDAO {

    /**
     * 각 시도별 평균, 최소, 최대 이동거리
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> travelDistance(int month) throws Exception;

    /**
     * 각 시도별 평균, 최소, 최대 소요시간
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> useTime(int month) throws Exception;

    /**
     * 지역별 배송 건수
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> deliveriesCount() throws Exception;

    /**
     * 지역별 평균 이동 시간
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> travelTime() throws Exception;
}
