package com.takensoft.pohangTp.meatKorea.service;

import com.takensoft.pohangTp.meatKorea.dao.MeatKoreaDAO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

@Service
public class MeatKoreaService {

    private final MeatKoreaDAO meatKoreaDAO;

    public MeatKoreaService(MeatKoreaDAO meatKoreaDAO) {
        this.meatKoreaDAO = meatKoreaDAO;
    }

    /**
     * 각 시도별 평균, 최소, 최대 이동거리
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> travelDistance(int month) throws Exception {
        List<HashMap<String, Object>> travelDistance = meatKoreaDAO.travelDistance(month);

        for(HashMap<String, Object> one : travelDistance) {
            if("제주특별자치도".equals(one.get("city").toString())) {
                one.replace("city", "제주");
            }
        }

        return travelDistance;
    }

    /**
     * 각 시도별 평균, 최소, 최대 소요시간
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> useTime(int month) throws Exception {
        List<HashMap<String, Object>> useTime = meatKoreaDAO.useTime(month);

        for(HashMap<String, Object> one : useTime) {
            if("제주특별자치도".equals(one.get("city").toString())) {
                one.replace("city", "제주");
            }
        }

        return useTime;
    }

    /**
     * 지역별 배송 건수
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> deliveriesCount() throws Exception {
        List<HashMap<String, Object>> deliveriesCount =  meatKoreaDAO.deliveriesCount();

        for(HashMap<String, Object> one : deliveriesCount) {
            if("제주특별자치도".equals(one.get("city").toString())) {
                one.replace("city", "제주");
            }
        }

        return deliveriesCount;
    }

    /**
     * 지역별 평균 이동 시간
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    public List<HashMap<String, Object>> travelTime() throws Exception {
        List<HashMap<String, Object>> travelTime =   meatKoreaDAO.travelTime();

        for(HashMap<String, Object> one : travelTime) {
            if("제주특별자치도".equals(one.get("city").toString())) {
                one.replace("city", "제주");
            }
        }
        return travelTime;
    }
}
