package com.takensoft.pohangTp.meatKorea.web;

import com.takensoft.pohangTp.meatKorea.service.MeatKoreaService;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;

@Controller
public class MeatKoreaController {

    private final MeatKoreaService meatKoreaService;

    public MeatKoreaController(MeatKoreaService meatKoreaService) {
        this.meatKoreaService = meatKoreaService;
    }

    /**
     * 각 시도별 평균, 최소, 최대 이동거리
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    @RequestMapping(value = "/meatKorea/travelDistance.json" , method = RequestMethod.POST)
    public ModelAndView travelDistance (@RequestBody HashMap<String, Object> params) throws Exception {
        int month = 0;
        if(params.get("distanceMonth") != null) {
            month = Integer.parseInt(params.get("distanceMonth").toString());
        }
        ModelAndView mav = new ModelAndView("jsonView");
        mav.addObject("travelDistance", meatKoreaService.travelDistance(month));
        return mav;
    }

    /**
     * 각 시도별 평균, 최소, 최대 소요시간
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    @RequestMapping(value = "/meatKorea/useTime.json" , method = RequestMethod.POST)
    public ModelAndView useTime (@RequestBody HashMap<String, Object> params) throws Exception {
        int month = 0;
        if(params.get("timeMonth") != null) {
            month = Integer.parseInt(params.get("timeMonth").toString());
        }

        ModelAndView mav = new ModelAndView("jsonView");
        mav.addObject("useTime", meatKoreaService.useTime(month));
        return mav;
    }

    /**
     * 지역별 배송 건수
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    @RequestMapping(value = "/meatKorea/deliveriesCount.json" , method = RequestMethod.POST)
    public ModelAndView deliveriesCount () throws Exception {
        ModelAndView mav = new ModelAndView("jsonView");
        mav.addObject("deliveriesCount", meatKoreaService.deliveriesCount());
        return mav;
    }

    /**
     * 지역별 평균 이동 시간
     *
     * @author 김성훈
     * @since 2024.01.17
     */
    @RequestMapping(value = "/meatKorea/travelTime.json" , method = RequestMethod.POST)
    public ModelAndView travelTime () throws Exception {
        ModelAndView mav = new ModelAndView("jsonView");
        mav.addObject("travelTime", meatKoreaService.travelTime());
        return mav;
    }
}
